<script>

export default {
        /** eseguito quando il componente viene caricato */
        mounted(){
            //carica il metodo che carica i video
            this.fetchVideos();
        },
        methods:{
            async fetchVideos(){
                console.log("recupero l'elenco dei video");
                //eseguo la richiesta http get per prendere i video
                var response= await fetch("http://localhost:8000/api/videos");
                var videos=await response.json();
                this.videos=videos;
            }
        },
        data(){
            return{
                videos:[], //new Array()
            }
        }
    }

</script>

<template>
  <div>
    <div class="videosContainer">
      <h1>Elenco dei video</h1>
      <div v-for="video in videos" :key="video.id" class="videoItem">
        <router-link :to="{name: 'watch', params: {id:video.id}}" >
        <span class="title">{{ video.title }}</span></router-link>   
        
        <div>
            <iframe height="250" :src="video.url" title="YouTube video player" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>
        </div>
        <div class="description">{{ video.description }}</div>
        <div class="insertDate">{{ video.insertDate}}</div>
      </div>
    </div>
  </div>
</template>

<style>
    .videosContainer{
        display: flex;
        flex-direction: column;
        gap: 10px;
        margin: 10px;
        
    }
    .videoItem:hover{
        filter: brightness(90%);
    }
    .videoItem{
        display: flex;
        flex-direction: column;
        gap: 10px;
        box-shadow: 0px 0px 2px 2px rgba(0,0,0,0.1);
        padding: 10px;
        border-radius: 4px;
        background-color: white;
        cursor: pointer;
    }
    .videoItem .title{
        font-size: 18px;
        font-weight: bold;
    }
    .videoItem .description{
        font-size: 15px;
    }
    .videoItem .insertDate{
        font-size: 13px;
    }
</style>